import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;

/**
 * Menu Principal de Sistema de Facturacion
 * 
 * @author G. Cherencio 
 * @version 1.0
 */
public class AppView {
    private JFrame fr = new JFrame("Sistema Facturacion");
    private JLabel lblMsg = new JLabel("Mensajes de la aplicacion");
    private JMenuBar mb = new JMenuBar();
    private JMenu mnuAr = new JMenu("Archivo");
    private JMenu mnuPr = new JMenu("Productos");
    private JMenu mnuCl = new JMenu("Clientes");
    private JMenu mnuFa = new JMenu("Facturacion");
    private JMenuItem mitArSalir = new JMenuItem("Salir");
    private JMenuItem mitPr1 = new JMenuItem("Productos");
    private JMenuItem mitCl1 = new JMenuItem("Clientes");
    private JMenuItem mitFa1 = new JMenuItem("Crear Factura");
    private JMenuItem mitFa2 = new JMenuItem("Confirmar Factura");
    private JMenuItem mitFa3 = new JMenuItem("Pagar Factura");

    /**
     * Constructor for objects of class AppView
     */
    public AppView() {
        // armar Menu
        // agrego menu items al menu archivo
        mnuAr.add(mitArSalir);
        mnuPr.add(mitPr1);
        mnuCl.add(mitCl1);
        mnuFa.add(mitFa1);
        mnuFa.add(mitFa2);
        mnuFa.add(mitFa3);
        
        // agrego el menu archivo al menu bar
        mb.add(mnuAr);
        mb.add(mnuPr);
        mb.add(mnuCl);
        mb.add(mnuFa);
        
        // seteo el menu bar del JFrame
        fr.setJMenuBar(mb);
        
        // implementamos eventos de la GUI
        // ABM CLIENTES
        mitCl1.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                lblMsg.setText("");
                JPanel p = new JPanel();
                ClienteModel cm = new ClienteModel();
                JTable tbl = new JTable(cm);
                cm.setJTable(tbl);
                tbl.addKeyListener(cm);
                JScrollPane sp = new JScrollPane(tbl,
                    JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
                p.add(sp);
                fr.getContentPane().removeAll();
                fr.getContentPane().add(p,BorderLayout.CENTER);
                fr.getContentPane().add(lblMsg,BorderLayout.SOUTH);
                fr.invalidate(); // notificamos que la vista actual es invalida!
                fr.validate(); // valide la vista actual!
            }
        });
        
        // ABM PRODUCTOS
        mitPr1.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                lblMsg.setText("");
                JPanel p = new JPanel();
                ProductoModel cm = new ProductoModel();
                JTable tbl = new JTable(cm);
                cm.setJTable(tbl);
                tbl.addKeyListener(cm);
                JScrollPane sp = new JScrollPane(tbl,
                    JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
                p.add(sp);
                fr.getContentPane().removeAll();
                fr.getContentPane().add(p,BorderLayout.CENTER);
                fr.getContentPane().add(lblMsg,BorderLayout.SOUTH);
                fr.invalidate(); // notificamos que la vista actual es invalida!
                fr.validate(); // valide la vista actual!
            }
        });
        
        mitFa1.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                JPanel p = new FacturaView(lblMsg);
                fr.getContentPane().removeAll();
                fr.getContentPane().add(p,BorderLayout.CENTER);
                fr.getContentPane().add(lblMsg,BorderLayout.SOUTH);
                fr.invalidate(); // notificamos que la vista actual es invalida!
                fr.validate(); // valide la vista actual!
            }
        });
        
        // SALIR DE APLICACION
        mitArSalir.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                if ( JOptionPane.showOptionDialog(null,"¿Esta Seguro que Desea Salir de la Aplicacion?",
                        "Sistema Facturacion", JOptionPane.YES_NO_OPTION, JOptionPane.INFORMATION_MESSAGE,
                            null,new String[] { "Si", "No" } , "Si") == 0 ) {
                    // desconectar Base de Datos??
                    FBCon.closeAll();
                    System.exit(0);
                }
            }
        });
        
        fr.addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent windowEvent) {
                FBCon.closeAll();
                System.exit(0);
            }
        });        
        
        // seleccionamos un Layout Manager
        fr.setLayout(new BorderLayout());
        fr.add(lblMsg,BorderLayout.SOUTH);
        fr.setSize(600,600);
        fr.setLocationRelativeTo(null);
        fr.setVisible(true);
        if ( !Util.loginOk ) {
            JOptionPane.showMessageDialog(fr, "Debe Estar Registrado para Usar esta pantalla", "Sistema Facturacion - Error", JOptionPane.ERROR_MESSAGE);
            System.exit(0);
        }
        
    }
    
    public static void main(String[] arg) {
        new AppView();
    }

}
