import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;
import java.text.*;
import java.sql.*;
/**
 * Vista correspondiente a la creacion de Factura
 * 
 * @author G. Cherencio
 * @version 1.0
 */
public class FacturaView extends JPanel {
    private JLabel lblmsg = null;
    private JLabel lblnro = new JLabel("Nro");
    private JLabel lblfec = new JLabel("Fecha");
    private JLabel lblcli = new JLabel("Cliente");
    private JLabel lbltot = new JLabel("Total");
    private JLabel lblpro = new JLabel("Producto");
    private JTextField txtfec = new JTextField();
    private JTextField txtnro = new JTextField();
    private JTextField txttot = new JTextField("0.0");
    private JComboBox<String> cbocli = new JComboBox<String>();
    private JComboBox<String> cbopro = new JComboBox<String>();
    private JButton btnOk = new JButton("Crear");
    private JButton btnPr = new JButton("Set Producto");
    
    /**
     * Constructor for objects of class FacturaView
     */
    public FacturaView() {
    }
    public FacturaView(JLabel lmsg) {
        lblmsg = lmsg;
        lblmsg.setText("Creacion de Factura!");
        txtfec.setEnabled(false);
        txtnro.setEnabled(false);
        txttot.setEnabled(false);
        cbocli.setModel(new DefaultComboBoxModel<String>());
        cbopro.setModel(new DefaultComboBoxModel<String>());
        setFecha(); // fecha actual en formato dd/mm/yyyy
        setNro(); // ultimo nro de factura + 1
        setCboCli(); // cargo combo de clientes
        setCboPro(); // cargo combo de productos
        // armo interfaz grafica
        setLayout(new BorderLayout());
        JPanel psup = new JPanel();
        psup.add(lblnro);
        psup.add(txtnro);
        psup.add(lblfec);
        psup.add(txtfec);
        psup.add(lblcli);
        psup.add(cbocli);
        JPanel pinf = new JPanel();
        pinf.add(lbltot);
        pinf.add(txttot);
        pinf.add(lblpro);
        pinf.add(cbopro);
        pinf.add(btnPr);
        pinf.add(btnOk);
        add(psup,BorderLayout.NORTH);
        add(pinf,BorderLayout.SOUTH);
    }
    private void setFecha() {
        SimpleDateFormat sdf = new SimpleDateFormat("dd/MM/yyyy");
        txtfec.setText(sdf.format(new java.util.Date()));
    }
    private void setNro() {
        try {
            FBCon f = FBCon.getFBCon(0);
            ResultSet rs = f.getResultSet("SELECT COALESCE(MAX(NRO),0)+1 AS NRO FROM TBL_FACTURA");
            if(rs.next()) {
                txtnro.setText(""+rs.getInt("nro"));
            }
            f.close(rs);
        } catch(SQLException sqle) {
            // Error recuperando clientes de la base de datos
            System.err.println("FacturaView: Error, "+sqle.getMessage());
            lblmsg.setText(sqle.getMessage());
        }
    }
    private void setCboCli() {
        try {
            FBCon f = FBCon.getFBCon(0);
            ResultSet rs = f.getResultSet("SELECT DESCR || ' (' || IDC || ')' AS DESCR FROM TBL_CLIENTE ORDER BY DESCR ASC");
            cbocli.removeAllItems();
            while(rs.next()) {
                cbocli.addItem(rs.getString("descr"));
            }
            f.close(rs);
        } catch(SQLException sqle) {
            // Error recuperando clientes de la base de datos
            System.err.println("FacturaView: Error, "+sqle.getMessage());
            lblmsg.setText(sqle.getMessage());
        }
    }
    private void setCboPro() {
        try {
            FBCon f = FBCon.getFBCon(0);
            ResultSet rs = f.getResultSet("SELECT DESCR || ' (' || IDP || ')' AS DESCR FROM TBL_PRODUCTO ORDER BY DESCR ASC");
            cbopro.removeAllItems();
            while(rs.next()) {
                cbopro.addItem(rs.getString("descr"));
            }
            f.close(rs);
        } catch(SQLException sqle) {
            // Error recuperando clientes de la base de datos
            System.err.println("FacturaView: Error, "+sqle.getMessage());
            lblmsg.setText(sqle.getMessage());
        }
    }
}
